题目来源==》AcWing第830题

题目

给定一个长度为 N 的整数数列,输出每个数左边第一个比它小的数,如果不存在则输出 −1。

输入格式

第一行包含整数 N,表示数列长度。
第二行包含 N 个整数,表示整数数列。

输出格式

共一行,包含 N 个整数,其中第 i 个数表示第 i 个数的左边第一个比它小的数,如果不存在则输出 −1。

数据范围

1≤N≤105
1≤数列中元素≤109

输入样例:

5
3 4 2 7 5

输出样例:

-1 3 -1 2 2

解题思路

分析题目,发现可以利用栈的特点来做这题。将数据入栈,由左到右的数进栈后就是由上到下。要找出左边第一个比当前数小的数对应栈就是由栈定扫描到栈底。

while(top && stack[top] >= x) top --; 

每个数进栈前先将与栈顶比较,如果比当前数大则出栈。保证栈的前一个元素比x小。因为出栈的数大于等于当前数,且在后面数的较左方,因此也不会影响后面的结果。然后如果栈不为空,则现在的栈顶元素就是当前数x左边第一个比小的数,栈为空则x左边的数均大于等于x。

图解:

单调栈图解

题目代码

#include <iostream>
using namespace std;
//单调栈
const int N = 100010;
int stack[N],top;

int main(){
    top = 0; //栈初始化
    int m, x;
    cin >> m;
    for(int i = 0; i < m; i++){
         cin >> x;
         //如果栈不为空,从栈定开始遍历,将比x大的数出栈
         //出栈的数比x大,且在x左边。
         while(top && stack[top] >= x) top --; 
         //栈为空,说明栈的元素都比x大
         if(!top) cout << "-1 " ; 
         //栈不为空,则栈定元素则是在x左边第一个比x小的数
         else cout << stack[top] <<" "; 
         stack[++ top] = x; // x入栈
    }
    // cout << endl;
    // while(top) cout<<stack[top--] <<" "; //栈由顶到底遍历
    return 0;
}
Logo

北京人形旗下天工造物具身智能开源社区,聚焦具身天工与慧思开物两大平台

更多推荐